import { Entry, KoconutPrimitive, KoconutEquatable } from "../../../module.internal";
export declare class Pair<FirstType, SecondType> implements KoconutEquatable {
    private firstElement;
    private secondElement;
    static from<FirstType, SecondType>(pair: [FirstType, SecondType]): Pair<FirstType, SecondType>;
    constructor(firstElement: FirstType, secondElement: SecondType);
    get first(): FirstType;
    get second(): SecondType;
    toString(): string;
    toArray(): Array<FirstType | SecondType>;
    toEntry(): Entry<FirstType, SecondType>;
    equalsTo(other: Pair<FirstType, SecondType>): boolean;
}
export declare class KoconutPair<FirstType, SecondType> extends KoconutPrimitive<Pair<FirstType, SecondType>> implements KoconutEquatable {
    constructor(first?: FirstType | null, second?: SecondType | null);
    equalsTo(other: KoconutPair<FirstType, SecondType>): boolean;
}
